Args <- commandArgs(TRUE);

tempdir = Args[1];
samplefil = Args[2];
workdir = Args[3];
max_sample = as.integer(Args[4]);
n_sample_job = as.integer(Args[5]);

sampleIDs    <- readLines(samplefil)
nsamples     <- length(sampleIDs)

n_total <- trunc( max_sample / n_sample_job) * n_sample_job
if ( n_total < max_sample ) n_total <-  n_total + n_sample_job

n_diag     <- n_total / n_sample_job
n_diag_arg <- matrix(NA,n_diag,2)
k <- 1
for (i in 1:n_diag) {
    n_diag_arg[i,1] <- k
    n_diag_arg[i,2] <- k + n_sample_job-1
    k <- k + n_sample_job
}

n_diag_arg[ n_diag_arg[,1] > max_sample, 1] <- max_sample
n_diag_arg[ n_diag_arg[,2] > max_sample, 2] <- max_sample

n_rect <- 0
if(n_diag>=2){ 	# ++ by chen
	if(max_sample > n_sample_job*(n_diag-0.5) || max_sample == n_sample_job*n_diag ) {
		n_rect <- n_diag*(n_diag-1);
	} else {
		n_rect <- (n_diag-1)^2;
	}
	print(n_rect)
	n_rect_arg <- matrix(NA, n_diag*(n_diag-1), 4)
	k <- n_sample_job + 1
	row <- 1
	for (i in 2:n_diag) {
	   start <- 1
	   for (j in 1:(i-1) ) {
	       n_rect_arg[row,1] <- k
	       n_rect_arg[row,2] <- k + n_sample_job/ 2 - 1
	       n_rect_arg[row,3] <- start
	       n_rect_arg[row,4] <- start + n_sample_job - 1

	       row <- row + 1

	       n_rect_arg[row,1] <- k + n_sample_job/ 2
	       n_rect_arg[row,2] <- k + n_sample_job- 1
	       n_rect_arg[row,3] <- start
	       n_rect_arg[row,4] <- start + n_sample_job - 1

	       start <- start + n_sample_job
	       row <- row + 1
	   }
	   k <- k + n_sample_job
	}


	sel <- !(n_rect_arg[,1] > max_sample) & !(n_rect_arg[,3] > max_sample)
	n_rect_arg <- n_rect_arg[sel, ] 


	n_rect_arg[ n_rect_arg[,1] > max_sample, 1] <- max_sample
	n_rect_arg[ n_rect_arg[,2] > max_sample, 2] <- max_sample
	n_rect_arg[ n_rect_arg[,3] > max_sample, 3] <- max_sample
	n_rect_arg[ n_rect_arg[,4] > max_sample, 4] <- max_sample

	n_jobs      <- length(n_diag_arg[,1]) + length(n_rect_arg[,1])

} else {  # ++ by chen

	n_jobs <- length(n_diag_arg[,1])  # ++ by chen
	
}         # ++ by chen

n_diag <- length(n_diag_arg[,1])
if(n_diag>=2){ 	# ++ by chen
n_rect <- length(n_rect_arg[,1])
} else {    # ++ by chen
 n_rect = 0;  # ++ by chen
}

### now read data

data_matrix <- matrix(NA,nsamples,nsamples)
colnames(data_matrix) <- sampleIDs
for (count_diag in 1:n_diag) {
    infil  <- paste (tempdir,"diag_",n_diag_arg[count_diag,1],".",n_diag_arg[count_diag,2],"_.csv",sep="")
    data   <- read.csv( infil,header=F )

    m <- 0
    n <- 0
    for (i in n_diag_arg[count_diag,1]:n_diag_arg[count_diag,2]) {
       m <- m +1
       for (j in n_diag_arg[count_diag,1]:i) {
            n <- n +1
            data_matrix[i,j] <- data[m,n]
           } # end j
      n <- 0
      } # end i
} # end count_diag

if(n_rect>=1){ # ++ by chen
for (count_rect in 1:n_rect) {
    infil  <- paste (tempdir,"rect_",n_rect_arg[count_rect,1],".",n_rect_arg[count_rect,2],"_",n_rect_arg[count_rect,3],".",n_rect_arg[count_rect,4],"_.csv",sep="")
    data   <- read.csv( infil,header=F )
    m <- 0
    n <- 0
    for (i in n_rect_arg[count_rect,1]:n_rect_arg[count_rect,2]) {
       m <- m+1
       for (j in n_rect_arg[count_rect,3]:n_rect_arg[count_rect,4])  {
       n <- n +1
        data_matrix[i,j] <- data[m,n]
           } # end j
      n <- 0
      } # end i
} # end count_rect
} #++ by chen


for (i in 2:nsamples)
   for (j in 1:(i-1)) data_matrix[j,i] <- data_matrix[i,j]


sd_PCAinput <- rep(NA,nsamples)
for (i in 1:nsamples) sd_PCAinput[i] <- sqrt(data_matrix[i,i])
print(summary(sd_PCAinput))

write.table(format(data_matrix,scientific = TRUE,digits=15), paste(workdir,"PCAinput_cov.csv",sep=""),sep=",",row.names = F, col.names = T)

## now on correltions

data_matrix <- matrix(NA,nsamples,nsamples)
colnames(data_matrix) <- sampleIDs
for (count_diag in 1:n_diag) {
    infil  <- paste (tempdir,"diagst_",n_diag_arg[count_diag,1],".",n_diag_arg[count_diag,2],"_.csv",sep="")
    data   <- read.csv( infil,header=F )

    m <- 0
    n <- 0
    for (i in n_diag_arg[count_diag,1]:n_diag_arg[count_diag,2]) {
       m <- m +1
       for (j in n_diag_arg[count_diag,1]:i) {
            n <- n +1
            data_matrix[i,j] <- data[m,n]
           } # end j
      n <- 0
      } # end i
} # end count_diag

if(n_rect>=1){ # ++ by chen
for (count_rect in 1:n_rect) {
    infil  <- paste (tempdir,"rectst_",n_rect_arg[count_rect,1],".",n_rect_arg[count_rect,2],"_",n_rect_arg[count_rect,3],".",n_rect_arg[count_rect,4],"_.csv",sep="")
    data   <- read.csv( infil,header=F )
    m <- 0
    n <- 0
    for (i in n_rect_arg[count_rect,1]:n_rect_arg[count_rect,2]) {
       m <- m+1
       for (j in n_rect_arg[count_rect,3]:n_rect_arg[count_rect,4])  {
       n <- n +1
        data_matrix[i,j] <- data[m,n]
           } # end j
      n <- 0
      } # end i
} # end count_rect
} #++ by chen


for (i in 2:nsamples)
   for (j in 1:(i-1)) data_matrix[j,i] <- data_matrix[i,j]

tmp <- rep(NA,nsamples)
for (i in 1:nsamples) tmp[i] <- sqrt(data_matrix[i,i])

sd_PCAinput <- data.frame(sampleIDs,sd_PCAinput,tmp)
colnames(sd_PCAinput) <- c("sampleIDCasCtr","sd_cov","sd_cor")
print( summary(sd_PCAinput) )


#rownames(sd_PCAinput) <- sampleIDs

write.table(format(sd_PCAinput,scientific = TRUE,digits=15), paste(workdir,"sd_PCAinput.csv",sep=""),sep=",",row.names = F, col.names = T)


write.table(format(data_matrix,scientific = TRUE,digits=15), paste(workdir,"PCAinput_cor.csv",sep=""),sep=",",row.names = F, col.names = T)

