func_partitionXXT2scripts = function(max_sample, max_site, n_parallel_proc, max_memory){

	n_division = 1;

	while(n_division<=max_sample){
		n_sample_job = ceiling(max_sample/n_division);
		# make sure it is even
		if(n_sample_job %% 2 !=0) {
			n_sample_job = n_sample_job + 1
		}
		mem_requirement = max_site*(n_sample_job/2*3*8 + 64)/2^30 + 0.3; # empirical formula right now

		######################
		n_total <- trunc( max_sample / n_sample_job) * n_sample_job
		if ( n_total < max_sample ) n_total <-  n_total + n_sample_job
		
		n_diag     <- n_total / n_sample_job
		n_rect <- 0
		if(n_diag>=2){ 	# ++ by chen
			if(max_sample > n_sample_job*(n_diag-0.5) || max_sample == n_sample_job*n_diag ) {
				n_rect <- n_diag*(n_diag-1);
			} else {
				n_rect <- (n_diag-1)^2;
			}
		}

		n_jobs = n_diag + n_rect;
		mem_requirement = max_site*(n_sample_job/2*3*8 + 64)/2^30 + 0.3; # empirical formula right now
		residual = n_jobs %% n_parallel_proc;
		multiplier = floor(n_jobs/n_parallel_proc);
		assignment = matrix(multiplier, 1, n_parallel_proc);
		if(residual > 0) {
			assignment[1:residual] = assignment[1:residual] + 1;
		}
		
		if(mem_requirement <= max_memory && 
			(
				n_jobs %% n_parallel_proc == 0 || 			  # perfect even
				length(which(assignment == max(assignment))) >= 0.8*n_parallel_proc ||     # the majority has the same max number of jobs
				max(assignment) - min(assignment) <= 0.1*min(assignment)  # the difference is very small
			) &&
			n_jobs >= n_parallel_proc					  # make sure all slots are used for calculation
		  ){  
			break;
		}
		
		n_division = n_division + 1;
	}
	cat("The maximal number of samples in each diagonal chunck is ", n_sample_job, "\n");
	cat("The estimated maximal memory required for each script is ", mem_requirement, " G\n");
	cat("The total number of partitioned diagonal chunks of XXT is ", n_diag, "\n");
	cat("The total number of partitioned rectangular chunks of XXT is ", n_rect, "\n");
	cat("These will be computed in ", n_parallel_proc, " scripts \n");
	cat("Task distribution in scripts\n")
	colnames(assignment)=paste("scripts", 1:n_parallel_proc, sep="")
	rownames(assignment)="";
	print(assignment);
	return(n_sample_job)
}