# calculate PCs from the dot product matrix
# input:
# XXT: the dot product matrix, X is centered by the sample mean
pcaFromXXT = function(XXT){
    N = dim(XXT)[1];
    rs = eigen(1/(N-1) * XXT, symmetric=T);
    dSq = rs$values;
    u = rs$vectors;
    dSq[abs(dSq)<1e-13] = 0;   # Set eigenvalues close to 0 to 0.
    u = u[, dSq>0];
    dSq = dSq[dSq>0];
    PCs = t( t(u) * sqrt(dSq) ) * sqrt(N - 1);
    lambda = dSq;   # Becasue the covariance function is (1/(N-1)) * XTX 
    return(list(lambda, PCs, u));
}