# validate association test reuslts
# validation_association.R

Args <- commandArgs(TRUE);
covdir = Args[1];
pheno_file = Args[2];
association_workdir = Args[3];
test_label = Args[4];
chr_begin = as.integer(Args[5]);
chr_end = as.integer(Args[6]);


phenoFile = paste(pheno_file, sep="");
phenoData = read.csv(phenoFile, header=T, as.is=T);
sampleIDs = as.matrix(phenoData[,1]);
outcome = as.matrix(phenoData[,2]);
if(dim(phenoData)[2]>2){
	covariates = as.matrix(phenoData[,3:dim(phenoData)[2]])
}


N = length(outcome);

startPos = 1;
for (i in chr_begin:chr_end){
    chrFolder = paste(covdir, "/chr", i, sep="");
    for (j in 1:N){
        coverageFile = paste(chrFolder, "/", sampleIDs[j], ".csv", sep="");
        coverageData= read.csv(coverageFile);
        coverageData = as.matrix(coverageData[,2]);
        if(j == 1){
            numberOfCites = dim(coverageData)[1];
        } else if(numberOfCites !=dim(coverageData)[1]){
            print(paste("Error: number of cites are different from file: ", coverageFile));
        }
        if(j == 1){
            XFromFile = matrix(NA, N, numberOfCites);
        }
        XFromFile[j,] = c(coverageData);
    }
    if(i == 1){
        XFromFileAllChr = XFromFile;
    } else {
        XFromFileAllChr = cbind(XFromFileAllChr, XFromFile);
    }
    
    startPos = startPos  + numberOfCites;
}

X = XFromFileAllChr;

# association test
testStatistics =  matrix(NA, dim(X)[2], 1);
pValues = matrix(NA, dim(X)[2], 1);

for (i in 1:dim(X)[2]) {
	if(dim(phenoData)[2]>2){
		model = summary(lm(outcome ~ X[,i] + covariates));
	} else {
		model = summary(lm(outcome ~ X[,i]));
	}
	testStatistics[i] = coefficients(model)[2,3];
	pValues[i] = coefficients(model)[2,4];
}

# readin the results
testStatistics2 =  double(0);
pValues2 = double(0);

for (chr in chr_begin:chr_end){
	rsFile = paste(association_workdir, "association_", test_label, "_chr", chr, ".csv", sep="");
	rsData = read.csv(rsFile);
	testStatistics2 = c(testStatistics2, as.matrix(rsData[,2]));
	pValues2 = c(pValues2, as.matrix(rsData[,3]));
}

print("norm of differences in test statistics")
print(norm(t(testStatistics2 - testStatistics), "F")); 
print("norm of differences in pvalues")
print(norm(t(pValues2 - pValues), "F")); 

