#include <cstdlib>

#include <iostream>
#include <fstream>
#include <string>
#include <sstream>

#include <vector>
#include <cmath>

#include <stdio.h>
#include "constants.h"


#include <iomanip>
using namespace std;

/* Read functions */
void read_sample(const char * filename);
void read_coord(const char * filename);

int n_sample, n_coord;

string samplenames[max_sample];
string cov_type;

double mean_vector[max_coord];
double SD_vector[max_coord];
int    coord[max_coord];


int main(int argc, char *argv[])
{
	#ifdef __WIN__
	  // Windows stuff
	  _setmaxstdio(2048);
	#endif

   int ichrom = atoi(argv[4]);

   cout << " Calculate descriptives for chromosome " << ichrom  << "\n";



   int i, j, sample_nr, iter;
   string STRING, subst, filna;
   size_t pos, oldpos;
   double mean=0.0, SD=0.0, denom=0.0, aux=0.0;

   stringstream ss;
   const char *ptemp;

   // ++ by chen
   string tempdir   = argv[3]; // where the descriptives store
   string covdir    = argv[1];
   string samplefil = argv[2];


	//@@@ read sample names
   ss << samplefil;
   filna = ss.str();
   ss.str(string());
   cout << " The name of the sample file is: "  << filna << "\n";
   ptemp= filna.c_str();

   read_sample(ptemp);
   cout << "Finish reading the sample file" << endl; // ++ by chen
   ifstream infils[n_sample];
   double cpgdata[n_sample];


   // read first sample to determine number of coordinates

   n_coord = 0;
   sample_nr = 0;
   ss << covdir << "chr" << ichrom << "/" << samplenames[sample_nr] << ".csv";
   filna.clear();
   filna = ss.str();
   ss.str(string());
   ptemp= filna.c_str();
   (infils[sample_nr]).open(ptemp);
   if (!(infils[sample_nr]).is_open()) cout << "file named " << ptemp << "  is not open \n";

   cout<< "Begin to read coverage file"<<endl; // ++ by chen
   read_coord(ptemp);
   cout << " The number of coordinates is: "  << n_coord << "\n";
//   for(i=0;i<n_coord;i++)   cout << "coord is " << coord[i]  << "\n";
   // ++ by chen
   infils[sample_nr].close();

   //@@@ create file names
   for(i=0;i<n_sample;i++) {
      ss << covdir << "chr" << ichrom << "/" << samplenames[i] << ".csv";
      filna.clear();
      filna = ss.str();
      ss.str(string());
      ptemp= filna.c_str();

//      cout << " filename is: "  << ptemp << "\n";


      (infils[i]).open(ptemp);
     }


    for(i=0;i<n_sample;i++) getline(infils[i],STRING); // Skipping the headers of the coverage files


    for(iter=0;iter<n_coord;iter++) {  // Here starts the loop on coordinates;
        mean=0.0, SD=0.0, aux=0.0, denom=0.0;

        for(i=0;i<n_sample;i++) {
       	      getline(infils[i],STRING);
              oldpos = STRING.find(',');
              pos=STRING.find(',',oldpos+1);
              subst = STRING.substr(oldpos+1,pos-oldpos-1);
              cpgdata[i] = atof(subst.c_str());
        }


        for(i=0;i<n_sample;i++) {
		mean +=cpgdata[i];

	}
        mean /= n_sample;

        for(i=0;i<n_sample;i++) {
        aux = cpgdata[i] - mean;
        SD += aux*aux;
        }

        SD /= (n_sample-1);
        if (SD > sd_threshold) SD = sqrt(SD);  else SD=0.0;

        mean_vector[iter] = mean;
        SD_vector[iter] = SD;


        }  // Here ends the loop on coordinates (loop iter);


    for(i=0;i<n_sample;i++) {
        (infils[i]).close();
      }

    ss << tempdir << "des_chr" << ichrom << ".csv";
    filna = ss.str();
    ss.str(string());
    cout << " The name of the output file is \n";
    cout << filna << "\n";
    ptemp= filna.c_str();

    ofstream outfile;
    outfile.open(ptemp);
    outfile << "coord,mean,SD" << "\n"; // Creating header
    outfile.precision(15);
    for(i=0;i<n_coord;i++) outfile << coord[i] << "," << mean_vector[i] << "," << SD_vector[i] << "\n";
    outfile.close();


    return EXIT_SUCCESS;
}



//-------------------------------------------------

void read_sample(const char * filename) {

    string STRING;
	ifstream infile;
	int i=0;

	infile.open (filename);

    while(!infile.eof()) {
	        getline(infile,STRING);
	    if(STRING.length()>0){    // ++ by chen
            samplenames[i] = STRING ;
            i++;
	    }    // ++ by chen
    }

    n_sample = i;

    infile.close();
}


void read_coord(const char * filename) {

    string STRING, subst;
	ifstream infile;
	size_t pos, oldpos, pos1, pos2;

	infile.open (filename);

	getline(infile,STRING); // Skipping the header

    while(!infile.eof()) { // To get you all the lines.

        getline(infile,STRING);
         if(STRING.length()>0){    // ++ by chen
        oldpos = 0;
	    pos=STRING.find(',');
        subst = STRING.substr(oldpos,pos-oldpos);
        coord[n_coord] = atoi(subst.c_str());   // Saving the first in 'coord'
        n_coord++;
	}    // ++ by chen
    }

    infile.close();


}




